代码随想录算法训练营第31天|455. 分发饼干,376. 摆动序列,53. 最大子序和

455. 分发饼干

class Solution {
    public int findContentChildren(int[] g, int[] s) {
        // 先给两个数组排序
         Arrays.sort(g);
         Arrays.sort(s);

        int j = s.length - 1; 
        int res = 0; // 记录最终结果
         for(int i = g.length - 1; i >= 0; i--){
             if( j >=0 && s[j] >= g[i]){
                 res++;
                 j--;
             }
         }

        return res;

    }
}

376. 摆动序列

链接: 参考讲解

  • 遇到的困难
    1 平坡的情况很难考虑到,单调平坡的情况也难考虑到
    2 一开始没有想到pre只记录波动的情况

在这里插入图片描述

class Solution {
    public int wiggleMaxLength(int[] a) {
        int res = 1;
        int pre = 0;
        int cur = 0;
        if(a.length <=1) return res; // 边界条件
        for(int i=0;i<a.length-1;i++){
            cur = a[i+1]-a[i];
            if((cur > 0 && pre <= 0) || (cur < 0 && pre >= 0)){
                res++;
                pre = cur; // 有波动就统计,没波动就不统计
            }
        }
        return res;   
    }
}

53. 最大子序和

链接: 参考讲解

解题关键为,在遍历数组是改变连续和开始的下标,当发现连续和小于0了直接将sum清零,重新开始标记。
看讲解中的动画演示理解会更加深刻
在这里插入图片描述

class Solution {
    public int maxSubArray(int[] nums) {
            int res = Integer.MIN_VALUE;
            int sum = 0;
            if(nums.length == 1) return nums[0];
            for(int x: nums){
                sum += x;
                res = Math.max(sum, res);
                if(sum <= 0) sum = 0; // 如果连续和小于0直接将sum清零
            }

            return res;
    }
}
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
第二十二算法训练营主要涵盖了Leetcode题目中的三道题目,分别是Leetcode 28 "Find the Index of the First Occurrence in a String",Leetcode 977 "有序数组的平方",和Leetcode 209 "长度最小的子数组"。 首先是Leetcode 28题,题目要求在给定的字符串中找到第一个出现的字符的索引。思路是使用双指针来遍历字符串,一个指向字符串的开头,另一个指向字符串的结尾。通过比较两个指针所指向的字符是否相等来判断是否找到了第一个出现的字符。具体实现的代码如下: ```python def findIndex(self, s: str) -> int: left = 0 right = len(s) - 1 while left <= right: if s[left == s[right]: return left left += 1 right -= 1 return -1 ``` 接下来是Leetcode 977题,题目要求对给定的有序数组中的元素进行平方,并按照非递减的顺序返回结果。这里由于数组已经是有序的,所以可以使用双指针的方法来解决问题。一个指针指向数组的开头,另一个指针指向数组的末尾。通过比较两个指针所指向的元素的绝对值的大小来确定哪个元素的平方应该放在结果数组的末尾。具体实现的代码如下: ```python def sortedSquares(self, nums: List[int]) -> List[int]: left = 0 right = len(nums) - 1 ans = [] while left <= right: if abs(nums[left]) >= abs(nums[right]): ans.append(nums[left ** 2) left += 1 else: ans.append(nums[right ** 2) right -= 1 return ans[::-1] ``` 最后是Leetcode 209题,题目要求在给定的数组中找到长度最小的子数组,

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值